 list      F=inhx8m, P=16F88, R=hex, N=0
#include  P16F88.inc; PIC definitions
 __config _config1,_INTRC_IO & _WDT_OFF & _LVP_OFF & _PWRTE_OFF & _MCLR_ON & _BODEN_ON & _LVP_OFF & _CPD_OFF & _WRT_PROTECT_OFF & _CCP1_RB3 & _CP_OFF
 __config _config2,_IESO_OFF & _FCMEN_OFF 
 Errorlevel -302      ; switches off Message [302]: Register in operand not in bank 0.


#define LED_RED porta,7
#define LED_GREEN porta,6

#define LCDRS porta,0
#define LCDE portb,5
#define LCD_P7 portb,3
#define LCD_P6 portb,1
#define LCD_P5 portb,0
#define LCD_P4 portb,4

#define TC_SO porta,4
#define TC_CS porta,3
#define TC_SCK porta,2

#define Pot_Pin porta,1
#define Heater_Pin portb,2


	cblock 0x20
		push_w,push_Status,push_PCLath
		WaitCounter,WaitCounter2
		PassArg1,PassArg2,PassArg3,PassArg4,PassArg5,PassArg6,PassArg7,PassArg8,PassArg9
		LCD_ByteSendBuffer
		Thermo_H,Thermo_L
		Thermo_H_B,Thermo_L_B
		AnalogValue
		AnalogValue_LAST
		AnalogValue_NEW
		AnalogValue_H,AnalogValue_L

		LoopCounter
		TempDifference
		TurnOnInterval
	endc

; Conastants --------------------------------------------------------------
GL_PID_1_L		=		d'12'		;On value (x 100 mSec) for 1 degree Lower
GL_PID_2_L		=		d'13'		;On value (x 100 mSec) for 2 degrees Lower
GL_PID_3_L		=		d'14'		;On value (x 100 mSec) for 3 degrees Lower

GL_PID_0		=		d'10'

GL_PID_1_H		=		d'12'		;On value (x 100 mSec) for 1 degree Higher
GL_PID_2_H		=		d'11'		;On value (x 100 mSec) for 2 degrees Higher
GL_PID_3_H		=		d'10'		;On value (x 100 mSec) for 3 degrees Higher


GL_PID_Full		=		d'15'		;
GL_PID_Off		=		d'0'		;


GL_Delay_Loops	=		d'15'		;Each on 100mSec


; Program Memory ----------------------------------------------------------
                org     0
                goto    Start
; Interrupt Service Routine -----------------------------------------------
                org     4               ; ISR beginning
                
; -------------------------------------------------------------------------
; -------------------------------------------------------------------------
; -------------------------------------------------------------------------
; Main Program ------------------------------------------------------------
Start
			bank1
			;movlw b'11111110'
			;movwf OSCTUNE			;Slightly decrease the frequency
			movlw b'01110000'
			movwf OSCCON
WaitForStableOscillator
			btfss OSCCON,IOFS
			goto WaitForStableOscillator

			movlw b'00110010'			;Set ports
			movwf TRISA
			movlw b'11000000'
			movwf TRISB
			
               movlw b'11111000'		; OPTION_REG setup
               movwf option_reg             
               clrf pie1				;
               clrf pie2				; No peripherial interrupt
               clrf ansel				; No analog to digital conversion
               clrf txsta				;Disable AUSART
               Bank0
               clrf intcon				;No Interrupt control
			clrf ccp1con			;Capture/Compare/PWM Disabled
			clrf t1con				;No TIMER 1

			;Watchdog Timer
			bank2 
			movlw b'00010111'
			movwf WDTCON
			bcf	WDTCON,SWDTEN		;Disable watchdog timer
			bank1
			;PSA must be to WDA (bsf OPTION_REG,psa)
			bcf OPTION_REG,PS2
			bcf OPTION_REG,PS1
			bsf OPTION_REG,PS0
			bank0

			;Disable Peripheral Interrupts
			bank1
			clrf PIE1
			clrf PIE2
			bank0
			;General
               clrf rcsta				;Disable AUSART receive
			clrf adcon0				;No analog to digital conversion

			call wait250msec
			call wait250msec
			call wait250msec
			;Setup ADC
			MOVLW b'00001001'
			movwf adcon0
			BANK1
			bsf ansel,1
			bank0

			bcf Heater_Pin
			bcf LED_RED
			bsf TC_CS
			bcf TC_SCK

			call StartupRoutine



			movlw d'100'
			movwf AnalogValue
			bsf adcon0,2	;Start first convertion
			btfsc adcon0,2
			goto $-1
			movf adresh,w
			movwf AnalogValue
			call Cont1
			clrf AnalogValue_LAST

			goto GetThermocoupleTemperature

MainLoop
			bsf LED_GREEN
			call wait50msec
			bcf LED_GREEN



			movlw GL_PID_Full
			movwf TurnOnInterval

			movf AnalogValue_H,w
			subwf Thermo_H,w
			btfss zero
			goto RunCycle		;If HIGH BYTES not ==, then do not check low bytes

			movf AnalogValue_L,w
			subwf Thermo_L,w
			movwf PassArg1
			movlw GL_PID_0
			btfsc zero
			goto SetAndRunCycle	;Is exactly the same!
			btfss carry
			goto PID_IsNegative

PID_IsPositive	;(Thermo-Analog > 0)
			;Must DECREASE Temperature!!!)
			movlw GL_PID_1_H
			decf PassArg1,f
			btfsc zero
			goto SetAndRunCycle	;1 Degree HIGHER

			movlw GL_PID_2_H
			decf PassArg1,f
			btfsc zero
			goto SetAndRunCycle	;2 Degrees HIGHER

			movlw GL_PID_3_H
			decf PassArg1,f
			btfsc zero
			goto SetAndRunCycle	;3 Degrees HIGHER

			movlw GL_PID_Off
			goto SetAndRunCycle

PID_IsNegative
			;Must INCREASE Temperature!!!)
			movlw GL_PID_1_L
			incf PassArg1,f
			btfsc zero
			goto SetAndRunCycle	;1 Degree LOWER
			
			movlw GL_PID_2_L
			incf PassArg1,f
			btfsc zero
			goto SetAndRunCycle	;2 Degree LOWER

			movlw GL_PID_3_L
			incf PassArg1,f
			btfsc zero
			goto SetAndRunCycle	;3 Degree LOWER


			movlw GL_Delay_Loops

SetAndRunCycle
			movwf TurnOnInterval
			goto RunCycle



RunCycle
			movf TurnOnInterval,f
			btfss zero
			call Heater_ON		;Interval >0

			movlw GL_Delay_Loops
			movwf LoopCounter

RunCycle_Loop
			call GetAnalogInput
			call wait100msec

			decf TurnOnInterval,f
			btfsc zero
			call Heater_OFF

			decfsz LoopCounter,f
			goto RunCycle_Loop




			goto GetThermocoupleTemperature



Heater_OFF
			bcf Heater_Pin
			bcf LED_RED
			return
Heater_ON
			bsf Heater_Pin
			bsf LED_RED
			return





GetAnalogInput
			;Get Analog Input
			btfsc adcon0,2
			goto Cont1
			movf adresh,w
			movwf AnalogValue
			movwf AnalogValue_NEW
			bsf adcon0,2
Cont1
			;Show SET POINT
			movlw b'00000011'
			CALL LCD_SetCursorPosition
			clrf PassArg2

			movf AnalogValue,w
			addlw d'150'
			movwf PassArg1
			btfsc carry
			incf PassArg2,f
			bcf carry
			rrf AnalogValue,f
			bcf carry
			rrf AnalogValue,f
			movf AnalogValue,w	
			addwf PassArg1,f
			btfsc carry
			incf PassArg2,f

			movf PassArg1,w
			movwf AnalogValue_L
			movf PassArg2,w
			movwf AnalogValue_H

			call b16_d5
			;movf PassArg6,w
			;addlw 0x30
			;call LCD_ShowCharacter
			movf PassArg5,w
			addlw 0x30
			call LCD_ShowCharacter
			movf PassArg4,w
			addlw 0x30
			call LCD_ShowCharacter
			movf PassArg3,w
			addlw 0x30
			call LCD_ShowCharacter

		
ShowBar
			;Show Bar
			movf AnalogValue_LAST,w
			subwf AnalogValue_NEW,w
			;btfsc zero
			;return 		;Analog value not changed
			;ELSE: Analog value changed!!!
			movf AnalogValue_NEW,w
			movwf AnalogValue_LAST

			movlw b'01000100'
			CALL LCD_SetCursorPosition

			movlw d'9'
			movwf passarg9
			
ShowBar_Next
			decf passarg9,f

			movf AnalogValue_NEW,w
			btfsc zero
			goto ShowBar_End

			movlw d'30'
			subwf AnalogValue_NEW,w
			;btfsc zero
			;goto ShowBar_IsFullBar

			btfss carry
			goto ShowBar_IsLastBar

			movlw 0x04
			call LCD_ShowCharacter	;Show a full bar
		
			movlw d'30'
			subwf AnalogValue_NEW,f
	
			goto ShowBar_Next


ShowBar_IsLastBar
			movlw d'6'
			subwf AnalogValue_NEW,f
			movlw 0x00
			btfss carry 
			goto ShowBar_IsLastBar_FIN

			movlw d'6'
			subwf AnalogValue_NEW,f
			movlw 0x01
			btfss carry 
			goto ShowBar_IsLastBar_FIN

			movlw d'6'
			subwf AnalogValue_NEW,f
			movlw 0x02
			btfss carry 
			goto ShowBar_IsLastBar_FIN

			movlw d'6'
			subwf AnalogValue_NEW,f
			movlw 0x03
			btfss carry 
			goto ShowBar_IsLastBar_FIN


			goto ShowBar_IsFullBar

ShowBar_IsLastBar_FIN
			call LCD_ShowCharacter
			goto ShowBar_End

ShowBar_IsFullBar
			movlw 0x04
			call LCD_ShowCharacter	;Show a full bar
ShowBar_End
			movf passarg9,w
			btfsc zero
			return

			movlw 0x05
			call LCD_ShowCharacter
			decfsz passarg9,f
			goto $-3
			return

GetThermocoupleTemperature

			bcf TC_SCK	; Clear clock
			nop
			bcf TC_CS	; Select chip
			
			clrf Thermo_H
			clrf Thermo_L

			movlw d'11'
			movwf PassArg1
	
			bsf carry
			btfss TC_SO
			bcf carry
			rlf Thermo_L,f
			rlf Thermo_H,f

TC_GetNextBit
			bsf TC_SCK
			bsf carry
			btfss TC_SO
			bcf carry
			rlf Thermo_L,f
			rlf Thermo_H,f
			
			bcf TC_SCK
			decfsz PassArg1,f
			goto TC_GetNextBit		

			bcf TC_SCK
			bsf TC_CS

			movlw b'00001100'
			CALL LCD_SetCursorPosition

			movf Thermo_L,w
			movwf Thermo_L_B
			movwf PassArg1
			movf Thermo_H,w
			movwf Thermo_H_B
			movwf PassArg2
			call b16_d5
			movf PassArg5,w
			btfss zero
			addlw 0x10
			addlw 0x20
			call LCD_ShowCharacter
			;movf PassArg5,w
			;addlw 0x30
			;call LCD_ShowCharacter
			movf PassArg4,w
			addlw 0x30
			call LCD_ShowCharacter
			movf PassArg3,w
			addlw 0x30
			call LCD_ShowCharacter
			movlw b'01000100'
			CALL LCD_SetCursorPosition


			goto MainLoop








;Check Heater On/Off
			movf AnalogValue_H,w
			subwf Thermo_H,w
			;Thermocouple HIGH - Setpoint HIGH
			btfss carry
			Goto TurnOnHeater			;Carry->Clear  => Negative (Set > Thermo)

			btfsc Zero
			Goto CheckLowBytes	;Zero->Set 		=> Set == Thermo
			;Else
TurnOffHeater
			bcf Heater_Pin
			bcf LED_RED
			goto mainloop
TurnOnHeater
			bsf Heater_Pin
			bsf LED_RED
			goto mainloop


CheckLowBytes
			;If HIGH bytes are equal:
			movf AnalogValue_l,w
			subwf Thermo_l,w
			btfss carry
			Goto TurnOnHeater			;Carry->Clear  => Negative (Set > Thermo)
			Goto TurnOffHeater



			
			
StartupRoutine
			bsf LCDE
			BSF LED_Green
			BCF LED_red
			call wait250msec
			call wait250msec
			call LCD_Initialize
			call wait250msec
			call LCD_DisplayTurnOn
			call wait250msec
			call LCD_CursorTurnOff
			call LCD_Clear
			call wait250msec
			;Entry mode set 
			movlw b'00000000'
			call LCD_SendByte
			movlw b'01100000'
			call LCD_SendByte
			call wait250msec
			call CreateExtraSymbols


			movlw b'00000001'
			CALL LCD_SetCursorPosition
			movlw 'S';
			call LCD_ShowCharacter
				CALL WAIT100MSEC
			movlw 'o';
			call LCD_ShowCharacter
				CALL WAIT100MSEC
			movlw 'l';
			call LCD_ShowCharacter
				CALL WAIT100MSEC
			movlw 'd';
			call LCD_ShowCharacter
				CALL WAIT100MSEC
			movlw 'e';
			call LCD_ShowCharacter
				CALL WAIT100MSEC
			movlw 'r';
			call LCD_ShowCharacter
				CALL WAIT100MSEC
			movlw ' ';
			call LCD_ShowCharacter
				CALL WAIT100MSEC
			movlw 'S';
			call LCD_ShowCharacter
				CALL WAIT100MSEC
			movlw 't';
			call LCD_ShowCharacter
				CALL WAIT100MSEC
			movlw 'a';
			call LCD_ShowCharacter
				CALL WAIT100MSEC
			movlw 't';
			call LCD_ShowCharacter
				CALL WAIT100MSEC
			movlw 'i';
			call LCD_ShowCharacter
				CALL WAIT100MSEC
			movlw 'o';
			call LCD_ShowCharacter
				CALL WAIT100MSEC
			movlw 'n';
			call LCD_ShowCharacter

			call Wait1Sec

			movlw b'01000011'
			CALL LCD_SetCursorPosition
			movlw 'P';
			call LCD_ShowCharacter
				CALL WAIT100MSEC
			movlw 'C';
			call LCD_ShowCharacter
				CALL WAIT100MSEC
			movlw 'B';
			call LCD_ShowCharacter
				CALL WAIT100MSEC
			movlw ' ';
			call LCD_ShowCharacter
				CALL WAIT100MSEC
			movlw 'H';
			call LCD_ShowCharacter
				CALL WAIT100MSEC
			movlw 'e';
			call LCD_ShowCharacter
				CALL WAIT100MSEC
			movlw 'a';
			call LCD_ShowCharacter
				CALL WAIT100MSEC
			movlw 'v';
			call LCD_ShowCharacter
				CALL WAIT100MSEC
			movlw 'e';
			call LCD_ShowCharacter
				CALL WAIT100MSEC
			movlw 'n';
			call LCD_ShowCharacter

				call Wait1Sec
				call Wait1Sec
				call Wait1Sec
				CALL LCD_Clear
				CALL WAIT250MSEC

			movlw b'00000000'
			CALL LCD_SetCursorPosition
			movlw 'S';
			call LCD_ShowCharacter
			movlw 'P';
			call LCD_ShowCharacter
			movlw ':';
			call LCD_ShowCharacter
			movlw b'00001010'
			CALL LCD_SetCursorPosition
			movlw 'R';
			call LCD_ShowCharacter
			movlw ':';
			call LCD_ShowCharacter
			movlw b'01000000'
			CALL LCD_SetCursorPosition
			movlw 'M';
			call LCD_ShowCharacter
			movlw 'i';
			call LCD_ShowCharacter
			movlw 'n';
			call LCD_ShowCharacter
			movlw 0x04;
			call LCD_ShowCharacter
			movlw b'01001101'
			CALL LCD_SetCursorPosition
			movlw 'M';
			call LCD_ShowCharacter
			movlw 'a';
			call LCD_ShowCharacter
			movlw 'x';
			call LCD_ShowCharacter




				return
CreateExtraSymbols
				;0x00
				movlw b'01000000'	;Set CGRAM Address
				call LCD_SendByte	;
				movlw b'00000000'	;
				call LCD_SendByte	;

				movlw b'00011111';
				call LCD_ShowCharacter
				movlw b'00010000'
				call LCD_ShowCharacter
				movlw b'00010000'
				call LCD_ShowCharacter
				movlw b'00010000';
				call LCD_ShowCharacter
				movlw b'00010000';
				call LCD_ShowCharacter
				movlw b'00010000';
				call LCD_ShowCharacter
				movlw b'00010000';
				call LCD_ShowCharacter
				movlw b'00011111';
				call LCD_ShowCharacter

				;0x01
				movlw b'01000000'	;Set CGRAM Address
				call LCD_SendByte	;
				movlw b'10000000'	;
				call LCD_SendByte	;

				movlw b'00011111';
				call LCD_ShowCharacter
				movlw b'00011000'
				call LCD_ShowCharacter
				movlw b'00011000'
				call LCD_ShowCharacter
				movlw b'00011000';
				call LCD_ShowCharacter
				movlw b'00011000';
				call LCD_ShowCharacter
				movlw b'00011000';
				call LCD_ShowCharacter
				movlw b'00011000';
				call LCD_ShowCharacter
				movlw b'00011111';
				call LCD_ShowCharacter


				;0x02
				movlw b'01010000'	;Set CGRAM Address
				call LCD_SendByte	;
				movlw b'00000000'	;
				call LCD_SendByte	;

				movlw b'00011111';
				call LCD_ShowCharacter
				movlw b'00011100'
				call LCD_ShowCharacter
				movlw b'00011100'
				call LCD_ShowCharacter
				movlw b'00011100';
				call LCD_ShowCharacter
				movlw b'00011100';
				call LCD_ShowCharacter
				movlw b'00011100';
				call LCD_ShowCharacter
				movlw b'00011100';
				call LCD_ShowCharacter
				movlw b'00011111';
				call LCD_ShowCharacter

				;0x03
				movlw b'01010000'	;Set CGRAM Address
				call LCD_SendByte	;
				movlw b'10000000'	;
				call LCD_SendByte	;

				movlw b'00011111';
				call LCD_ShowCharacter
				movlw b'00011110'
				call LCD_ShowCharacter
				movlw b'00011110'
				call LCD_ShowCharacter
				movlw b'00011110';
				call LCD_ShowCharacter
				movlw b'00011110';
				call LCD_ShowCharacter
				movlw b'00011110';
				call LCD_ShowCharacter
				movlw b'00011110';
				call LCD_ShowCharacter
				movlw b'00011111';
				call LCD_ShowCharacter


				;0x04
				movlw b'01100000'	;Set CGRAM Address
				call LCD_SendByte	;
				movlw b'00000000'	;
				call LCD_SendByte	;

				movlw b'00011111';
				call LCD_ShowCharacter
				movlw b'00011111'
				call LCD_ShowCharacter
				movlw b'00011111'
				call LCD_ShowCharacter
				movlw b'00011111';
				call LCD_ShowCharacter
				movlw b'00011111';
				call LCD_ShowCharacter
				movlw b'00011111';
				call LCD_ShowCharacter
				movlw b'00011111';
				call LCD_ShowCharacter
				movlw b'00011111';
				call LCD_ShowCharacter


				;0x05
				movlw b'01100000'	;Set CGRAM Address
				call LCD_SendByte	;
				movlw b'10000000'	;
				call LCD_SendByte	;

				movlw b'00011111';
				call LCD_ShowCharacter
				movlw b'00000000'
				call LCD_ShowCharacter
				movlw b'00000000'
				call LCD_ShowCharacter
				movlw b'00000000';
				call LCD_ShowCharacter
				movlw b'00000000';
				call LCD_ShowCharacter
				movlw b'00000000';
				call LCD_ShowCharacter
				movlw b'00000000';
				call LCD_ShowCharacter
				movlw b'00011111';
				call LCD_ShowCharacter

				;0x06
				movlw b'01110000'	;Set CGRAM Address
				call LCD_SendByte	;
				movlw b'00000000'	;
				call LCD_SendByte	;

				movlw b'00010000';
				call LCD_ShowCharacter
				movlw b'00010000'
				call LCD_ShowCharacter
				movlw b'00010000'
				call LCD_ShowCharacter
				movlw b'00010000';
				call LCD_ShowCharacter
				movlw b'00010000';
				call LCD_ShowCharacter
				movlw b'00010000';
				call LCD_ShowCharacter
				movlw b'00010000';
				call LCD_ShowCharacter
				movlw b'00010000';
				call LCD_ShowCharacter

				return

StartDelayCount movwf WaitCounter2		;1    
BackWaitLoop2
				movlw d'164'			;1
                call WaitWx4Cycles
				movlw d'164'			;1
                call WaitWx4Cycles
				nop
				nop
                decf WaitCounter2,f		;1
                btfss zero				;1
                goto BackWaitLoop2		;2
                return					;2
WaitWx4Cycles   movwf WaitCounter
BackWaitLoop    decfsz WaitCounter,f
                goto BackWaitLoop
                return
Wait1mSec       movlw d'1'
                goto StartDelayCount
Wait2mSec       movlw d'2'
                goto StartDelayCount
Wait4mSec       movlw d'4'
                goto StartDelayCount
Wait10mSec      movlw d'10'
                goto StartDelayCount
Wait50mSec      movlw d'50'
                goto StartDelayCount
Wait100mSec      movlw d'100'
                goto StartDelayCount
Wait250mSec     movlw d'250'
                goto StartDelayCount
Wait1Sec		call Wait250mSec
				call Wait250mSec
				call Wait250mSec
				goto Wait250mSec

LCD_SetCursorPosition
				movwf passarg1
				andlw b'00011111'
				movwf passarg2		;Col
				movlw b'11000000'
				andwf passarg1,f	;Row
				bcf carry
				rlf passarg1,f
				rlf passarg1,f
				rlf passarg1,f


				movlw 0x00	;Check for Row 1
				movf passarg1,f
				btfsc zero
				goto LCD_SetCursorPosition_Next
				movlw 0x40	;Check for Row 2
				decf passarg1,f
				btfsc zero
				goto LCD_SetCursorPosition_Next
				movlw 0x94	;Check for Row 3
				decf passarg1,f
				btfsc zero
				goto LCD_SetCursorPosition_Next
				movlw 0xd4	;Row 4
LCD_SetCursorPosition_Next	
				addwf passarg2,f
				bsf passarg2,7
				movlw b'11110000'
				andwf passarg2,w
				call LCD_SendByte

				swapf passarg2,f
				movlw b'11110000'
				andwf passarg2,w

				call LCD_SendByte
				call wait10msec
				RETURN
LCD_ShowCharacter	;Character within W
				movwf PassArg1
				bsf LCDRS
				call LCD_SendByte
				swapf PassArg1,w
				call LCD_SendByte
				bcf LCDRS
				return
LCD_Initialize
				movlw b'00110000'
				call LCD_SendByte
				call wait100msec
				movlw b'00110000'
				call LCD_SendByte
				call wait10msec
				movlw b'00110000'
				call LCD_SendByte


				movlw b'00100000'
				call LCD_SendByte

				movlw b'00100000'
				call LCD_SendByte
				movlw b'10000000'
				call LCD_SendByte

				movlw b'00000000'
				call LCD_SendByte
				movlw b'10000000'
				call LCD_SendByte

				movlw b'00000000'
				call LCD_SendByte
				movlw b'00010000'
				call LCD_SendByte

;				movlw b'00100000'
;				call LCD_SendByte
;				call wait10msec

;				movlw b'00100000'
;				call LCD_SendByte
;				movlw b'11100000'
;				call LCD_SendByte

				return

LCD_Clear
				movlw b'00000000'
				call LCD_SendByte
				movlw b'00010000'
				call LCD_SendByte
				return

LCD_DisplayTurnOff
				movlw b'00000000'
				call LCD_SendByte
				movlw b'10100000'
				call LCD_SendByte
				return

LCD_DisplayTurnOn
				movlw b'00000000'
				call LCD_SendByte
				movlw b'11100000'
				call LCD_SendByte
				return

LCD_CursorTurnOn
				movlw b'00000000'
				call LCD_SendByte
				movlw b'11100000'
				call LCD_SendByte
				return
LCD_CursorTurnOff
				movlw b'00000000'
				call LCD_SendByte
				movlw b'11000000'
				call LCD_SendByte
				return
LCD_SendByte
				movwf LCD_ByteSendBuffer
				bsf LCD_P4
				btfss LCD_ByteSendBuffer,4
				bcf LCD_P4
				bsf LCD_P5
				btfss LCD_ByteSendBuffer,5
				bcf LCD_P5
				bsf LCD_P6
				btfss LCD_ByteSendBuffer,6
				bcf LCD_P6
				bsf LCD_P7
				btfss LCD_ByteSendBuffer,7
				bcf LCD_P7
				bsf LCDE

				movlw d'60'
				movwf WaitCounter				
				decfsz WaitCounter,f
				goto $-1
	
				bcf LCDE

				movlw d'60'
				movwf WaitCounter				
				decfsz WaitCounter,f
				goto $-1


				return
b16_d5
				swapf PassArg1,w 
				addwf PassArg1,w 
				andlw 0x0f 
				skpndc 
				addlw 0x16 
				skpndc 
				addlw 0x06 
				addlw 0x06 
				skpdc 
				addlw -0x06
				;
				btfsc PassArg1,4
				addlw 0x15+0x06
				skpdc
				addlw -0x06 
				movwf PassArg3 
				;
				swapf PassArg2,w 
				addwf PassArg2,w 
				andlw 0x0f 
				skpndc 
				addlw 0x16 
				skpndc 
				addlw 0x06 
				addlw 0x06 
				skpdc 
				addlw -0x06
				btfsc PassArg2,0
				addlw 0x05+0x06
				skpdc
				addlw -0x06
				btfsc PassArg2,4
				addlw 0x15+0x06
				skpdc
				addlw -0x06 
				addlw 0x06
				addwf PassArg3,w
				skpdc
				addlw -0x06 
				movwf PassArg3
				movwf PassArg4
				swapf PassArg4,f
				movlw 0x0f
				andwf PassArg3,f 
				andwf PassArg4,f 
				rrf PassArg2,w 
				andlw 0x0f 
				addlw 0x06 
				skpdc
				addlw -0x06 
				addlw 0x06 
				addwf PassArg4,w
				skpdc
				addlw -0x06 
			
				btfsc PassArg1,5
				addlw 0x03+0x06
				skpdc
				addlw -0x06
				btfsc PassArg1,6
				addlw 0x06+0x06
				skpdc
				addlw -0x06
				btfsc PassArg1,7
				addlw 0x12+0x06
				skpdc
				addlw -0x06
				btfsc PassArg2,0
				addlw 0x25+0x06
				skpdc
				addlw -0x06
				btfsc PassArg2,5
				addlw 0x09+0x06
				skpdc
				addlw -0x06
				btfsc PassArg2,6
				addlw 0x08+0x06
				skpdc
				addlw -0x06
				btfsc PassArg2,7
				addlw 0x06+0x06
				skpdc
				addlw -0x06
				movwf PassArg4 
				swapf PassArg4,w
				andlw 0x0f
				btfsc PassArg2,1
				addlw 0x05+0x06
				skpdc
				addlw -0x06
				btfsc PassArg2,5
				addlw 0x01+0x06
				skpdc
				addlw -0x06
				btfsc PassArg2,6
				addlw 0x03+0x06
				skpdc
				addlw -0x06 
				btfsc PassArg2,7
				addlw 0x07+0x06
				skpdc
				addlw -0x06
				
				movwf PassArg5 
				swapf PassArg5,w
				movwf PassArg6
				movlw 0x0f 
				andwf PassArg4,f 
				andwf PassArg5,f 
				andwf PassArg6,f 
				rrf PassArg2,w 
				movwf PassArg7 
				rrf PassArg7,w 
				andlw 0x0f
				addlw 0x06
				skpdc 
				addlw -0x06
				
				addlw 0x06
				addwf PassArg6,w
				skpdc
				addlw -0x06 
				
				btfsc PassArg2,6
				addlw 0x16+0x06
				skpdc
				addlw -0x06 
				
				btfsc PassArg2,7
				addlw 0x32+0x06
				skpdc
				addlw -0x06 
				;
				movwf PassArg6 
				movwf PassArg7 
				swapf PassArg7,f 
				movlw 0x0f 
				andwf PassArg6,f 
				andwf PassArg7,f 
				return
Fins            
                end             ; end of program






